module Id = struct
  let name = "pr_gettext"
  let version = "$Id$"
end

module Make (Syntax : Camlp4.Sig.Camlp4Syntax)
  : Camlp4.Sig.Printer(Syntax.Ast).S =
struct
  module Loc = Syntax.Loc
  module Ast = Syntax.Ast
  class visitor = object
    inherit Ast.fold as super

    val t = []
    method t = t
    method expr = function
    | <:expr< f $str:singular$ >> ->
      let t = singular :: t in
      {< t = t >}
    | e -> super#expr e
  end

  let print_interf ?input_file:(_) ?output_file:(_) _ = ()

  let print_implem ?input_file:(_) ?output_file:(_) ast =
    let visitor = (new visitor)#str_item in
    let t = (visitor ast)#t in
    List.iter prerr_endline t
end
(* Register the new printer. *)
module M = Camlp4.Register.OCamlPrinter(Id)(Make)


